diff -uwbBpr libfloat/softfloat/bits64/softfloat.c SoftFloat-2a/softfloat/bits64/softfloat.c
--- libfloat/softfloat/bits64/softfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/softfloat.c	Mon Sep 20 11:47:08 1999
@@ -2963,9 +3240,95 @@ int32 floatx80_to_int32_round_to_zero( f
 /*
 -------------------------------------------------------------------------------
 Returns the result of converting the extended double-precision floating-
+point value `a' to the 64-bit two's complement integer format.  The
+conversion is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic---which means in particular that the conversion
+is rounded according to the current rounding mode.  If `a' is a NaN,
+the largest positive integer is returned.  Otherwise, if the conversion
+overflows, the largest integer with the same sign as `a' is returned.
+-------------------------------------------------------------------------------
+*/
+int64 floatx80_to_int64( floatx80 a )
+{
+    flag aSign;
+    int32 aExp, shiftCount;
+    bits64 aSig, aSigExtra;
+
+    aSig = extractFloatx80Frac( a );
+    aExp = extractFloatx80Exp( a );
+    aSign = extractFloatx80Sign( a );
+    shiftCount = 0x403E - aExp;
+    if ( shiftCount <= 0 ) {
+        if ( shiftCount ) {
+            float_raise( float_flag_invalid );
+            if (    ! aSign
+                 || (    ( aExp == 0x7FFF )
+                      && ( aSig != LIT64( 0x8000000000000000 ) ) )
+               ) {
+                return LIT64( 0x7FFFFFFFFFFFFFFF );
+            }
+            return (sbits64) LIT64( 0x8000000000000000 );
+        }
+        aSigExtra = 0;
+    }
+    else {
+        shift64ExtraRightJamming( aSig, 0, shiftCount, &aSig, &aSigExtra );
+    }
+    return roundAndPackInt64( aSign, aSig, aSigExtra );
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the extended double-precision floating-
+point value `a' to the 64-bit two's complement integer format.  The
+conversion is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic, except that the conversion is always rounded
+toward zero.  If `a' is a NaN, the largest positive integer is returned.
+Otherwise, if the conversion overflows, the largest integer with the same
+sign as `a' is returned.
+-------------------------------------------------------------------------------
+*/
+int64 floatx80_to_int64_round_to_zero( floatx80 a )
+{
+    flag aSign;
+    int32 aExp, shiftCount;
+    bits64 aSig;
+    int64 z;
+
+    aSig = extractFloatx80Frac( a );
+    aExp = extractFloatx80Exp( a );
+    aSign = extractFloatx80Sign( a );
+    shiftCount = aExp - 0x403E;
+    if ( 0 <= shiftCount ) {
+        aSig &= LIT64( 0x7FFFFFFFFFFFFFFF );
+        if ( ( a.high != 0xC03E ) || aSig ) {
+            float_raise( float_flag_invalid );
+            if ( ! aSign || ( ( aExp == 0x7FFF ) && aSig ) ) {
+                return LIT64( 0x7FFFFFFFFFFFFFFF );
+            }
+        }
+        return (sbits64) LIT64( 0x8000000000000000 );
+    }
+    else if ( aExp < 0x3FFF ) {
+        if ( aExp | aSig ) float_exception_flags |= float_flag_inexact;
+        return 0;
+    }
+    z = aSig>>( - shiftCount );
+    if ( (bits64) ( aSig<<( shiftCount & 63 ) ) ) {
+        float_exception_flags |= float_flag_inexact;
+    }
+    if ( aSign ) z = - z;
+    return z;
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the extended double-precision floating-
 point value `a' to the single-precision floating-point format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 floatx80_to_float32( floatx80 a )
@@ -2994,7 +3357,7 @@ float32 floatx80_to_float32( floatx80 a 
 Returns the result of converting the extended double-precision floating-
 point value `a' to the double-precision floating-point format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 floatx80_to_float64( floatx80 a )
@@ -3025,7 +3388,7 @@ float64 floatx80_to_float64( floatx80 a 
 Returns the result of converting the extended double-precision floating-
 point value `a' to the quadruple-precision floating-point format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 floatx80_to_float128( floatx80 a )
@@ -3052,7 +3415,7 @@ float128 floatx80_to_float128( floatx80 
 Rounds the extended double-precision floating-point value `a' to an integer,
 and returns the result as an extended quadruple-precision floating-point
 value.  The operation is performed according to the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_round_to_int( floatx80 a )
@@ -3070,7 +3433,7 @@ floatx80 floatx80_round_to_int( floatx80
         }
         return a;
     }
-    if ( aExp <= 0x3FFE ) {
+    if ( aExp < 0x3FFF ) {
         if (    ( aExp == 0 )
              && ( (bits64) ( extractFloatx80Frac( a )<<1 ) == 0 ) ) {
             return a;
@@ -3124,10 +3487,10 @@ floatx80 floatx80_round_to_int( floatx80
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the extended double-
-precision floating-point values `a' and `b'.  If `zSign' is true, the sum is
+precision floating-point values `a' and `b'.  If `zSign' is 1, the sum is
 negated before being returned.  `zSign' is ignored if the result is a NaN.
 The addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static floatx80 addFloatx80Sigs( floatx80 a, floatx80 b, flag zSign )
@@ -3191,10 +3554,10 @@ static floatx80 addFloatx80Sigs( floatx8
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the extended
-double-precision floating-point values `a' and `b'.  If `zSign' is true,
-the difference is negated before being returned.  `zSign' is ignored if the
+double-precision floating-point values `a' and `b'.  If `zSign' is 1, the
+difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static floatx80 subFloatx80Sigs( floatx80 a, floatx80 b, flag zSign )
@@ -3261,7 +3624,7 @@ static floatx80 subFloatx80Sigs( floatx8
 -------------------------------------------------------------------------------
 Returns the result of adding the extended double-precision floating-point
 values `a' and `b'.  The operation is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_add( floatx80 a, floatx80 b )
@@ -3283,7 +3646,7 @@ floatx80 floatx80_add( floatx80 a, float
 -------------------------------------------------------------------------------
 Returns the result of subtracting the extended double-precision floating-
 point values `a' and `b'.  The operation is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_sub( floatx80 a, floatx80 b )
@@ -3305,7 +3668,7 @@ floatx80 floatx80_sub( floatx80 a, float
 -------------------------------------------------------------------------------
 Returns the result of multiplying the extended double-precision floating-
 point values `a' and `b'.  The operation is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_mul( floatx80 a, floatx80 b )
@@ -3365,7 +3728,7 @@ floatx80 floatx80_mul( floatx80 a, float
 -------------------------------------------------------------------------------
 Returns the result of dividing the extended double-precision floating-point
 value `a' by the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_div( floatx80 a, floatx80 b )
@@ -3446,7 +3809,7 @@ floatx80 floatx80_div( floatx80 a, float
 -------------------------------------------------------------------------------
 Returns the remainder of the extended double-precision floating-point value
 `a' with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_rem( floatx80 a, floatx80 b )
@@ -3544,16 +3907,15 @@ floatx80 floatx80_rem( floatx80 a, float
 -------------------------------------------------------------------------------
 Returns the square root of the extended double-precision floating-point
 value `a'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 floatx80_sqrt( floatx80 a )
 {
     flag aSign;
     int32 aExp, zExp;
-    bits64 aSig0, aSig1, zSig0, zSig1;
+    bits64 aSig0, aSig1, zSig0, zSig1, doubleZSig0;
     bits64 rem0, rem1, rem2, rem3, term0, term1, term2, term3;
-    bits64 shiftedRem0, shiftedRem1;
     floatx80 z;
 
     aSig0 = extractFloatx80Frac( a );
@@ -3578,38 +3940,34 @@ floatx80 floatx80_sqrt( floatx80 a )
     }
     zExp = ( ( aExp - 0x3FFF )>>1 ) + 0x3FFF;
     zSig0 = estimateSqrt32( aExp, aSig0>>32 );
-    zSig0 <<= 31;
-    aSig1 = 0;
-    shift128Right( aSig0, 0, ( aExp & 1 ) + 2, &aSig0, &aSig1 );
-    zSig0 = estimateDiv128To64( aSig0, aSig1, zSig0 ) + zSig0 + 4;
-    if ( 0 <= (sbits64) zSig0 ) zSig0 = LIT64( 0xFFFFFFFFFFFFFFFF );
-    shortShift128Left( aSig0, aSig1, 2, &aSig0, &aSig1 );
+    shift128Right( aSig0, 0, 2 + ( aExp & 1 ), &aSig0, &aSig1 );
+    zSig0 = estimateDiv128To64( aSig0, aSig1, zSig0<<32 ) + ( zSig0<<30 );
+    doubleZSig0 = zSig0<<1;
     mul64To128( zSig0, zSig0, &term0, &term1 );
     sub128( aSig0, aSig1, term0, term1, &rem0, &rem1 );
     while ( (sbits64) rem0 < 0 ) {
         --zSig0;
-        shortShift128Left( 0, zSig0, 1, &term0, &term1 );
-        term1 |= 1;
-        add128( rem0, rem1, term0, term1, &rem0, &rem1 );
-    }
-    shortShift128Left( rem0, rem1, 63, &shiftedRem0, &shiftedRem1 );
-    zSig1 = estimateDiv128To64( shiftedRem0, shiftedRem1, zSig0 );
-    if ( (bits64) ( zSig1<<1 ) <= 10 ) {
+        doubleZSig0 -= 2;
+        add128( rem0, rem1, zSig0>>63, doubleZSig0 | 1, &rem0, &rem1 );
+    }
+    zSig1 = estimateDiv128To64( rem1, 0, doubleZSig0 );
+    if ( ( zSig1 & LIT64( 0x3FFFFFFFFFFFFFFF ) ) <= 5 ) {
         if ( zSig1 == 0 ) zSig1 = 1;
-        mul64To128( zSig0, zSig1, &term1, &term2 );
-        shortShift128Left( term1, term2, 1, &term1, &term2 );
+        mul64To128( doubleZSig0, zSig1, &term1, &term2 );
         sub128( rem1, 0, term1, term2, &rem1, &rem2 );
         mul64To128( zSig1, zSig1, &term2, &term3 );
         sub192( rem1, rem2, 0, 0, term2, term3, &rem1, &rem2, &rem3 );
         while ( (sbits64) rem1 < 0 ) {
             --zSig1;
-            shortShift192Left( 0, zSig0, zSig1, 1, &term1, &term2, &term3 );
+            shortShift128Left( 0, zSig1, 1, &term2, &term3 );
             term3 |= 1;
-            add192(
-                rem1, rem2, rem3, term1, term2, term3, &rem1, &rem2, &rem3 );
+            term2 |= doubleZSig0;
+            add192( rem1, rem2, rem3, 0, term2, term3, &rem1, &rem2, &rem3 );
         }
         zSig1 |= ( ( rem1 | rem2 | rem3 ) != 0 );
     }
+    shortShift128Left( 0, zSig1, 1, &zSig0, &zSig1 );
+    zSig0 |= doubleZSig0;
     return
         roundAndPackFloatx80(
             floatx80_rounding_precision, 0, zExp, zSig0, zSig1 );
@@ -3620,7 +3978,7 @@ floatx80 floatx80_sqrt( floatx80 a )
 -------------------------------------------------------------------------------
 Returns 1 if the extended double-precision floating-point value `a' is
 equal to the corresponding value `b', and 0 otherwise.  The comparison is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -3652,7 +4010,7 @@ flag floatx80_eq( floatx80 a, floatx80 b
 Returns 1 if the extended double-precision floating-point value `a' is
 less than or equal to the corresponding value `b', and 0 otherwise.  The
 comparison is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag floatx80_le( floatx80 a, floatx80 b )
@@ -3685,7 +4043,7 @@ flag floatx80_le( floatx80 a, floatx80 b
 -------------------------------------------------------------------------------
 Returns 1 if the extended double-precision floating-point value `a' is
 less than the corresponding value `b', and 0 otherwise.  The comparison
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -3720,7 +4078,7 @@ flag floatx80_lt( floatx80 a, floatx80 b
 Returns 1 if the extended double-precision floating-point value `a' is equal
 to the corresponding value `b', and 0 otherwise.  The invalid exception is
 raised if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag floatx80_eq_signaling( floatx80 a, floatx80 b )
@@ -3748,7 +4106,7 @@ flag floatx80_eq_signaling( floatx80 a, 
 Returns 1 if the extended double-precision floating-point value `a' is less
 than or equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs
 do not cause an exception.  Otherwise, the comparison is performed according
-to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag floatx80_le_quiet( floatx80 a, floatx80 b )
@@ -3785,7 +4143,7 @@ flag floatx80_le_quiet( floatx80 a, floa
 Returns 1 if the extended double-precision floating-point value `a' is less
 than the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause
 an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag floatx80_lt_quiet( floatx80 a, floatx80 b )
@@ -3825,7 +4183,7 @@ flag floatx80_lt_quiet( floatx80 a, floa
 -------------------------------------------------------------------------------
 Returns the result of converting the quadruple-precision floating-point
 value `a' to the 32-bit two's complement integer format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
@@ -3855,7 +4213,7 @@ int32 float128_to_int32( float128 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the quadruple-precision floating-point
 value `a' to the 32-bit two's complement integer format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic, except that the conversion is always rounded toward zero.  If
 `a' is a NaN, the largest positive integer is returned.  Otherwise, if the
 conversion overflows, the largest integer with the same sign as `a' is
@@ -3874,24 +4232,24 @@ int32 float128_to_int32_round_to_zero( f
     aExp = extractFloat128Exp( a );
     aSign = extractFloat128Sign( a );
     aSig0 |= ( aSig1 != 0 );
-    shiftCount = 0x402F - aExp;
-    if ( shiftCount < 17 ) {
+    if ( 0x401E < aExp ) {
         if ( ( aExp == 0x7FFF ) && aSig0 ) aSign = 0;
         goto invalid;
     }
-    else if ( 48 < shiftCount ) {
+    else if ( aExp < 0x3FFF ) {
         if ( aExp || aSig0 ) float_exception_flags |= float_flag_inexact;
         return 0;
     }
     aSig0 |= LIT64( 0x0001000000000000 );
+    shiftCount = 0x402F - aExp;
     savedASig = aSig0;
     aSig0 >>= shiftCount;
     z = aSig0;
     if ( aSign ) z = - z;
     if ( ( z < 0 ) ^ aSign ) {
  invalid:
-        float_exception_flags |= float_flag_invalid;
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+        float_raise( float_flag_invalid );
+        return aSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
     if ( ( aSig0<<shiftCount ) != savedASig ) {
         float_exception_flags |= float_flag_inexact;
@@ -3903,8 +4261,114 @@ int32 float128_to_int32_round_to_zero( f
 /*
 -------------------------------------------------------------------------------
 Returns the result of converting the quadruple-precision floating-point
+value `a' to the 64-bit two's complement integer format.  The conversion
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic---which means in particular that the conversion is rounded
+according to the current rounding mode.  If `a' is a NaN, the largest
+positive integer is returned.  Otherwise, if the conversion overflows, the
+largest integer with the same sign as `a' is returned.
+-------------------------------------------------------------------------------
+*/
+int64 float128_to_int64( float128 a )
+{
+    flag aSign;
+    int32 aExp, shiftCount;
+    bits64 aSig0, aSig1;
+
+    aSig1 = extractFloat128Frac1( a );
+    aSig0 = extractFloat128Frac0( a );
+    aExp = extractFloat128Exp( a );
+    aSign = extractFloat128Sign( a );
+    if ( aExp ) aSig0 |= LIT64( 0x0001000000000000 );
+    shiftCount = 0x402F - aExp;
+    if ( shiftCount <= 0 ) {
+        if ( 0x403E < aExp ) {
+            float_raise( float_flag_invalid );
+            if (    ! aSign
+                 || (    ( aExp == 0x7FFF )
+                      && ( aSig1 || ( aSig0 != LIT64( 0x0001000000000000 ) ) )
+                    )
+               ) {
+                return LIT64( 0x7FFFFFFFFFFFFFFF );
+            }
+            return (sbits64) LIT64( 0x8000000000000000 );
+        }
+        shortShift128Left( aSig0, aSig1, - shiftCount, &aSig0, &aSig1 );
+    }
+    else {
+        shift64ExtraRightJamming( aSig0, aSig1, shiftCount, &aSig0, &aSig1 );
+    }
+    return roundAndPackInt64( aSign, aSig0, aSig1 );
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the quadruple-precision floating-point
+value `a' to the 64-bit two's complement integer format.  The conversion
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
+returned.
+-------------------------------------------------------------------------------
+*/
+int64 float128_to_int64_round_to_zero( float128 a )
+{
+    flag aSign;
+    int32 aExp, shiftCount;
+    bits64 aSig0, aSig1;
+    int64 z;
+
+    aSig1 = extractFloat128Frac1( a );
+    aSig0 = extractFloat128Frac0( a );
+    aExp = extractFloat128Exp( a );
+    aSign = extractFloat128Sign( a );
+    if ( aExp ) aSig0 |= LIT64( 0x0001000000000000 );
+    shiftCount = aExp - 0x402F;
+    if ( 0 < shiftCount ) {
+        if ( 0x403E <= aExp ) {
+            aSig0 &= LIT64( 0x0000FFFFFFFFFFFF );
+            if (    ( a.high == LIT64( 0xC03E000000000000 ) )
+                 && ( aSig1 < LIT64( 0x0002000000000000 ) ) ) {
+                if ( aSig1 ) float_exception_flags |= float_flag_inexact;
+            }
+            else {
+                float_raise( float_flag_invalid );
+                if ( ! aSign || ( ( aExp == 0x7FFF ) && ( aSig0 | aSig1 ) ) ) {
+                    return LIT64( 0x7FFFFFFFFFFFFFFF );
+                }
+            }
+            return (sbits64) LIT64( 0x8000000000000000 );
+        }
+        z = ( aSig0<<shiftCount ) | ( aSig1>>( ( - shiftCount ) & 63 ) );
+        if ( (bits64) ( aSig1<<shiftCount ) ) {
+            float_exception_flags |= float_flag_inexact;
+        }
+    }
+    else {
+        if ( aExp < 0x3FFF ) {
+            if ( aExp | aSig0 | aSig1 ) {
+                float_exception_flags |= float_flag_inexact;
+            }
+            return 0;
+        }
+        z = aSig0>>( - shiftCount );
+        if (    aSig1
+             || ( shiftCount && (bits64) ( aSig0<<( shiftCount & 63 ) ) ) ) {
+            float_exception_flags |= float_flag_inexact;
+        }
+    }
+    if ( aSign ) z = - z;
+    return z;
+
+}
+
+/*
+-------------------------------------------------------------------------------
+Returns the result of converting the quadruple-precision floating-point
 value `a' to the single-precision floating-point format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -3940,7 +4404,7 @@ float32 float128_to_float32( float128 a 
 -------------------------------------------------------------------------------
 Returns the result of converting the quadruple-precision floating-point
 value `a' to the double-precision floating-point format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -3977,7 +4441,7 @@ float64 float128_to_float64( float128 a 
 Returns the result of converting the quadruple-precision floating-point
 value `a' to the extended double-precision floating-point format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 floatx80 float128_to_floatx80( float128 a )
@@ -4015,7 +4479,7 @@ floatx80 float128_to_floatx80( float128 
 Rounds the quadruple-precision floating-point value `a' to an integer, and
 returns the result as a quadruple-precision floating-point value.  The
 operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_round_to_int( float128 a )
@@ -4062,7 +4526,7 @@ float128 float128_round_to_int( float128
         z.low &= ~ roundBitsMask;
     }
     else {
-        if ( aExp <= 0x3FFE ) {
+        if ( aExp < 0x3FFF ) {
             if ( ( ( (bits64) ( a.high<<1 ) ) | a.low ) == 0 ) return a;
             float_exception_flags |= float_flag_inexact;
             aSign = extractFloat128Sign( a );
@@ -4117,10 +4581,10 @@ float128 float128_round_to_int( float128
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the quadruple-precision
-floating-point values `a' and `b'.  If `zSign' is true, the sum is negated
-before being returned.  `zSign' is ignored if the result is a NaN.  The
-addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+floating-point values `a' and `b'.  If `zSign' is 1, the sum is negated
+before being returned.  `zSign' is ignored if the result is a NaN.
+The addition is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float128 addFloat128Sigs( float128 a, float128 b, flag zSign )
@@ -4196,10 +4660,10 @@ static float128 addFloat128Sigs( float12
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the quadruple-
-precision floating-point values `a' and `b'.  If `zSign' is true, the
+precision floating-point values `a' and `b'.  If `zSign' is 1, the
 difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float128 subFloat128Sigs( float128 a, float128 b, flag zSign )
@@ -4282,7 +4746,7 @@ static float128 subFloat128Sigs( float12
 -------------------------------------------------------------------------------
 Returns the result of adding the quadruple-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_add( float128 a, float128 b )
@@ -4304,7 +4768,7 @@ float128 float128_add( float128 a, float
 -------------------------------------------------------------------------------
 Returns the result of subtracting the quadruple-precision floating-point
 values `a' and `b'.  The operation is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_sub( float128 a, float128 b )
@@ -4326,7 +4790,7 @@ float128 float128_sub( float128 a, float
 -------------------------------------------------------------------------------
 Returns the result of multiplying the quadruple-precision floating-point
 values `a' and `b'.  The operation is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_mul( float128 a, float128 b )
@@ -4391,7 +4855,7 @@ float128 float128_mul( float128 a, float
 -------------------------------------------------------------------------------
 Returns the result of dividing the quadruple-precision floating-point value
 `a' by the corresponding value `b'.  The operation is performed according to
-the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_div( float128 a, float128 b )
@@ -4476,16 +4940,15 @@ float128 float128_div( float128 a, float
 -------------------------------------------------------------------------------
 Returns the remainder of the quadruple-precision floating-point value `a'
 with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_rem( float128 a, float128 b )
 {
     flag aSign, bSign, zSign;
     int32 aExp, bExp, expDiff;
-    bits64 aSig0, aSig1, bSig0, bSig1;
-    bits64 q, term0, term1, term2, allZero, alternateASig0, alternateASig1;
-    bits64 sigMean1;
+    bits64 aSig0, aSig1, bSig0, bSig1, q, term0, term1, term2;
+    bits64 allZero, alternateASig0, alternateASig1, sigMean1;
     sbits64 sigMean0;
     float128 z;
 
@@ -4588,16 +5051,15 @@ float128 float128_rem( float128 a, float
 -------------------------------------------------------------------------------
 Returns the square root of the quadruple-precision floating-point value `a'.
 The operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float128 float128_sqrt( float128 a )
 {
     flag aSign;
     int32 aExp, zExp;
-    bits64 aSig0, aSig1, zSig0, zSig1, zSig2;
+    bits64 aSig0, aSig1, zSig0, zSig1, zSig2, doubleZSig0;
     bits64 rem0, rem1, rem2, rem3, term0, term1, term2, term3;
-    bits64 shiftedRem0, shiftedRem1;
     float128 z;
 
     aSig1 = extractFloat128Frac1( a );
